function SimpleButton(controller, placement, cssClass, action) {
	this.controller = controller;
	this.action = action;
	this.position = {
			x: placement.x - (SimpleButton.size / 2),
			y: placement.y - (SimpleButton.size / 2),
	};
	var button = this;
	this.shape = controller.draw
	.circle(SimpleButton.size)
	.move(this.position.x, this.position.y)
	.attr({
		'class': 'button button-simple ' + cssClass,
		fill: '#da532c',
		opacity: 0.5,
	})
	.on('click', function() {
		if (button.controller.ready()) {
			button.execute();
		}
	});
}

SimpleButton.create = function(controller, placement, cssClass, action) {
	return new SimpleButton(controller, placement, cssClass, action);
};

SimpleButton.size = Controller.height / 5;

SimpleButton.prototype.execute = function() {
	this.shape.opacity(1);
	this.controller.perform(this.action);
	var button = this;
	window.setTimeout(function() {
		button.shape.opacity(0.5);
	}, 250);
};